## teakra 0.0~git20250117.4dfebf8

=== src/CMakeLists.txt ===
include(CreateDirectoryGroups)

add_library(teakra
    ../include/teakra/disassembler.h
    ../include/teakra/teakra.h
    ahbm.cpp
    ahbm.h
    apbp.cpp
    apbp.h
    bit.h
    btdmp.cpp
    btdmp.h
    common_types.h
    crash.h
    decoder.h
    disassembler.cpp
    dma.cpp
    dma.h
    timer.cpp
    timer.h
    icu.h
    interpreter.h
    matcher.h
    memory_interface.cpp
    memory_interface.h
    mmio.cpp
    mmio.h
    operand.h
    parser.cpp
    processor.cpp
    processor.h
    register.h
    shared_memory.h
    teakra.cpp
    test.h
    test_generator.cpp
    test_generator.h
)

create_target_directory_groups(teakra)

target_link_libraries(teakra PRIVATE Threads::Threads)
target_include_directories(teakra
                           PUBLIC
                            "$<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>"
                            "$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>"
                           PRIVATE .)
target_compile_options(teakra PRIVATE ${TEAKRA_CXX_FLAGS})

add_library(teakra_c
    ../include/teakra/disassembler_c.h
    ../include/teakra/teakra_c.h
    disassembler_c.cpp
    teakra_c.cpp
)
target_link_libraries(teakra_c PRIVATE teakra)

set_target_properties(teakra teakra_c PROPERTIES VERSION 0)

if (TEAKRA_BUILD_TOOLS)
    add_subdirectory(coff_reader)
    add_subdirectory(dsp1_reader)
    add_subdirectory(test_generator)
    add_subdirectory(test_verifier)
    add_subdirectory(mod_test_generator)
    add_subdirectory(step2_test_generator)
    add_subdirectory(makedsp1)
endif()

=== src/coff_reader/CMakeLists.txt ===
include(CreateDirectoryGroups)

add_executable(coff_reader
    coff.h
    main.cpp
)
create_target_directory_groups(coff_reader)
target_link_libraries(coff_reader PRIVATE teakra)
target_include_directories(coff_reader PRIVATE .)
target_compile_options(coff_reader PRIVATE ${TEAKRA_CXX_FLAGS})

=== src/test_generator/CMakeLists.txt ===
include(CreateDirectoryGroups)

add_executable(test_generator
    main.cpp
)
create_target_directory_groups(test_generator)
target_link_libraries(test_generator PRIVATE teakra)
target_include_directories(test_generator PRIVATE .)
target_compile_options(test_generator PRIVATE ${TEAKRA_CXX_FLAGS})

=== debian/changelog ===
teakra (0.0~git20250117.4dfebf8-2) unstable; urgency=medium

  * d/*.install: s/x86_64-linux-gnu/*/ (Closes: #1102926)

 -- Andrea Pappacoda <tachi@debian.org>  Tue, 15 Apr 2025 18:48:33 +0200

teakra (0.0~git20250117.4dfebf8-1) unstable; urgency=low

  * Initial release. (Closes: #1093213)

 -- Andrea Pappacoda <tachi@debian.org>  Tue, 11 Mar 2025 23:02:27 +0100

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=+all qa=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_SHARED_LIBS=true

ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
execute_after_dh_auto_install:
	mkdir -p debian/tmp/src
	printf '%s\n' '<meta name="color-scheme" content="light dark">'                           >  debian/tmp/README.html
	cmark README.md | sed -E -e '/img src="http/d' -e 's/href="([^"]+)\.md"/href="\1.html"/g' >> debian/tmp/README.html
	for file in src/*.md; \
	do \
		name=$$(basename "$$file" .md); \
		printf '%s\n' '<meta name="color-scheme" content="light dark">' >  "debian/tmp/src/$$name.html"; \
		cmark "$$file" | sed -E 's/href="([^"]+)\.md"/href="\1.html"/g' >> "debian/tmp/src/$$name.html"; \
	done
endif

=== debian/watch ===
version=4
opts="mode=git, pretty=0.0~git%cd.%h, pgpmode=none" \
https://github.com/wwylele/teakra.git HEAD

## teakra 0.0~git20250805.a66efb9

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.14)
project(teakra CXX)

# Determine if we're built as a subproject (using add_subdirectory)
# or if this is the master project.
set(MASTER_PROJECT OFF)
if (CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR)
  set(MASTER_PROJECT ON)
endif()

# Useful built-in modules
include(CMakeDependentOption)
include(CTest)
include(GNUInstallDirs)

option(TEAKRA_WARNINGS_AS_ERRORS "Warnings as errors" ${MASTER_PROJECT})
option(TEAKRA_BUILD_TOOLS "Build tools" ${MASTER_PROJECT})
cmake_dependent_option(TEAKRA_BUILD_UNIT_TESTS "Build unit tests" "${MASTER_PROJECT}" "BUILD_TESTING" OFF)
option(TEAKRA_RUN_TESTS "Run Teakra accuracy tests" OFF)

# Set hard requirements for C++
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

# Warn on CMake API deprecations
set(CMAKE_WARN_DEPRECATED ON)

# Disable in-source builds
set(CMAKE_DISABLE_SOURCE_CHANGES ON)
set(CMAKE_DISABLE_IN_SOURCE_BUILD ON)
if ("${CMAKE_SOURCE_DIR}" STREQUAL "${CMAKE_BINARY_DIR}")
    message(SEND_ERROR "In-source builds are not allowed.")
endif()

# Add the module directory to the list of paths
list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/CMakeModules")

# Compiler flags
if (MSVC)
    set(TEAKRA_CXX_FLAGS
        /std:c++latest # CMAKE_CXX_STANDARD as no effect on MSVC until CMake 3.10.
        /W3
        /permissive- # Stricter C++ standards conformance
        /MP
        /Zi
        /Zo
        /EHsc
        /Zc:throwingNew # Assumes new never returns null
        /Zc:inline # Omits inline functions from object-file output
        /DNOMINMAX
        /D_CRT_SECURE_NO_WARNINGS)

    if (TEAKRA_WARNINGS_AS_ERRORS)
        list(APPEND TEAKRA_CXX_FLAGS
             /WX)
    endif()
else()
    set(TEAKRA_CXX_FLAGS
        -Wall
        -Wextra
        -Wcast-qual
        -pedantic
        -pedantic-errors
        -Wfatal-errors
        -Wno-error=maybe-uninitialized
        -Wno-missing-braces
        -Wno-unused-parameter)

    if (TEAKRA_WARNINGS_AS_ERRORS)
        list(APPEND TEAKRA_CXX_FLAGS
             -Werror)
    endif()
endif()

# Prefer the -pthread flag on Linux.
set(THREADS_PREFER_PTHREAD_FLAG ON)
find_package(Threads REQUIRED)

if (NOT TEAKRA_TEST_ASSETS_DIR)
  set(TEAKRA_TEST_ASSETS_DIR "${CMAKE_CURRENT_BINARY_DIR}")
endif()

# External libraries
add_subdirectory(externals)

# Teakra project files
add_subdirectory(src)

# Teakra tests
if (TEAKRA_BUILD_UNIT_TESTS)
  add_subdirectory(tests)
endif()

# Installation
install(TARGETS teakra teakra_c EXPORT teakraTargets)
install(EXPORT teakraTargets
    DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/teakra"
    NAMESPACE "${PROJECT_NAME}::"
    FILE "teakraConfig.cmake"
)

install(DIRECTORY
    "include/teakra"
    TYPE INCLUDE
)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -3,6 +3,7 @@
 add_library(teakra
     ../include/teakra/disassembler.h
     ../include/teakra/teakra.h
+    ../include/teakra/impl/register.h
     ahbm.cpp
     ahbm.h
     apbp.cpp
@@ -29,7 +30,6 @@
     parser.cpp
     processor.cpp
     processor.h
-    register.h
     shared_memory.h
     teakra.cpp
     test.h
@@ -44,7 +44,7 @@
                            PUBLIC
                             "$<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>"
                             "$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>"
-                           PRIVATE .)
+                           PRIVATE . ../include/teakra/impl)
 target_compile_options(teakra PRIVATE ${TEAKRA_CXX_FLAGS})
 
 add_library(teakra_c

=== tests/CMakeLists.txt ===
add_executable(teakra_tests
    dma.cpp
    btdmp.cpp
    interpreter.cpp
    main.cpp
    timer.cpp
)

target_include_directories(teakra_tests PRIVATE ../include/teakra/impl/)
target_link_libraries(teakra_tests PRIVATE teakra catch)
target_compile_options(teakra_tests PRIVATE ${TEAKRA_CXX_FLAGS})

add_test(teakra_tests teakra_tests)

=== hwtest/dspapbptester/Makefile ===
#---------------------------------------------------------------------------------
.SUFFIXES:
#---------------------------------------------------------------------------------

ifeq ($(strip $(DEVKITARM)),)
$(error "Please set DEVKITARM in your environment. export DEVKITARM=<path to>devkitARM")
endif

TOPDIR ?= $(CURDIR)
include $(DEVKITARM)/3ds_rules

#---------------------------------------------------------------------------------
# TARGET is the name of the output
# BUILD is the directory where object files & intermediate files will be placed
# SOURCES is a list of directories containing source code
# DATA is a list of directories containing data files
# INCLUDES is a list of directories containing header files
# ROMFS is the directory which contains the RomFS, relative to the Makefile (Optional)
#---------------------------------------------------------------------------------
TARGET		:=	$(notdir $(CURDIR))
BUILD		:=	build
SOURCES		:=	source
DATA		:=	data
INCLUDES	:=	include
#ROMFS		:=	romfs

#---------------------------------------------------------------------------------
# options for code generation
#---------------------------------------------------------------------------------
ARCH	:=	-march=armv6k -mtune=mpcore -mfloat-abi=hard -mtp=soft

CFLAGS	:=	-g -Wall -O2 -mword-relocations \
			-fomit-frame-pointer -ffunction-sections \
			$(ARCH)

CFLAGS	+=	$(INCLUDE) -DARM11 -D_3DS

CXXFLAGS	:= $(CFLAGS) -fno-rtti -fno-exceptions -std=gnu++11

ASFLAGS	:=	-g $(ARCH)
LDFLAGS	=	-specs=3dsx.specs -g $(ARCH) -Wl,-Map,$(notdir $*.map)

LIBS	:= -lctru -lm

#---------------------------------------------------------------------------------
# list of directories containing libraries, this must be the top level containing
# include and lib
#---------------------------------------------------------------------------------
LIBDIRS	:= $(CTRULIB)


ifneq ($(BUILD),$(notdir $(CURDIR)))
#---------------------------------------------------------------------------------

export OUTPUT	:=	$(CURDIR)/$(TARGET)
export TOPDIR	:=	$(CURDIR)

export VPATH	:=	$(foreach dir,$(SOURCES),$(CURDIR)/$(dir)) \
			$(foreach dir,$(DATA),$(CURDIR)/$(dir))

export DEPSDIR	:=	$(CURDIR)/$(BUILD)

CFILES		:=	$(foreach dir,$(SOURCES),$(notdir $(wildcard $(dir)/*.c)))
CPPFILES	:=	$(foreach dir,$(SOURCES),$(notdir $(wildcard $(dir)/*.cpp)))
SFILES		:=	$(foreach dir,$(SOURCES),$(notdir $(wildcard $(dir)/*.s)))
PICAFILES	:=	$(foreach dir,$(SOURCES),$(notdir $(wildcard $(dir)/*.v.pica)))
SHLISTFILES	:=	$(foreach dir,$(SOURCES),$(notdir $(wildcard $(dir)/*.shlist)))
BINFILES	:=	$(foreach dir,$(DATA),$(notdir $(wildcard $(dir)/*.*)))

#---------------------------------------------------------------------------------
# use CXX for linking C++ projects, CC for standard C
#---------------------------------------------------------------------------------
ifeq ($(strip $(CPPFILES)),)
#---------------------------------------------------------------------------------
	export LD	:=	$(CC)
#---------------------------------------------------------------------------------
else
#---------------------------------------------------------------------------------
	export LD	:=	$(CXX)
#---------------------------------------------------------------------------------
endif
#---------------------------------------------------------------------------------

export OFILES	:=	$(addsuffix .o,$(BINFILES)) \
			$(PICAFILES:.v.pica=.shbin.o) $(SHLISTFILES:.shlist=.shbin.o) \
			$(CPPFILES:.cpp=.o) $(CFILES:.c=.o) $(SFILES:.s=.o)

export INCLUDE	:=	$(foreach dir,$(INCLUDES),-I$(CURDIR)/$(dir)) \
			$(foreach dir,$(LIBDIRS),-I$(dir)/include) \
			-I$(CURDIR)/$(BUILD)

export LIBPATHS	:=	$(foreach dir,$(LIBDIRS),-L$(dir)/lib)

.PHONY: $(BUILD) clean all

#---------------------------------------------------------------------------------
all: $(BUILD)

$(BUILD):
	@[ -d $@ ] || mkdir -p $@
	@$(MAKE) --no-print-directory -C $(BUILD) -f $(CURDIR)/Makefile

#---------------------------------------------------------------------------------
clean:
	@echo clean ...
	@rm -fr $(BUILD) $(TARGET).cxi $(TARGET).cia $(TARGET).elf


#---------------------------------------------------------------------------------
else

DEPENDS	:=	$(OFILES:.o=.d)

#---------------------------------------------------------------------------------
# main targets
#---------------------------------------------------------------------------------
all: $(OUTPUT).3dsx $(OUTPUT).cia

ifeq ($(strip $(NO_SMDH)),)
$(OUTPUT).3dsx	:	$(OUTPUT).elf $(OUTPUT).smdh
else
$(OUTPUT).3dsx	:	$(OUTPUT).elf
endif

$(OUTPUT).cia   :	$(OUTPUT).cxi
	@makerom -f cia -o $(OUTPUT).cia -target t -i $(OUTPUT).cxi:0:0
	@echo built ... $(OUTPUT).cia

$(OUTPUT).cxi   :   $(OUTPUT).elf $(OUTPUT).smdh $(TOPDIR)/rsf.rsf $(TOPDIR)/banner.bnr
	@makerom -o $(OUTPUT).cxi -rsf $(TOPDIR)/rsf.rsf -target t -elf $(OUTPUT).elf -icon $(OUTPUT).smdh -banner $(TOPDIR)/banner.bnr
	@echo built ... $(OUTPUT).cxi

$(OUTPUT).elf	:	$(OFILES)

#---------------------------------------------------------------------------------
# you need a rule like this for each extension you use as binary data
#---------------------------------------------------------------------------------
%.bin.o	:	%.bin
#---------------------------------------------------------------------------------
	@echo $(notdir $<)
	@$(bin2o)

#---------------------------------------------------------------------------------
# rules for assembling GPU shaders
#---------------------------------------------------------------------------------
define shader-as
	$(eval CURBIN := $(patsubst %.shbin.o,%.shbin,$(notdir $@)))
	picasso -o $(CURBIN) $1
	bin2s $(CURBIN) | $(AS) -o $@
	echo "extern const u8" `(echo $(CURBIN) | sed -e 's/^\([0-9]\)/_\1/' | tr . _)`"_end[];" > `(echo $(CURBIN) | tr . _)`.h
	echo "extern const u8" `(echo $(CURBIN) | sed -e 's/^\([0-9]\)/_\1/' | tr . _)`"[];" >> `(echo $(CURBIN) | tr . _)`.h
	echo "extern const u32" `(echo $(CURBIN) | sed -e 's/^\([0-9]\)/_\1/' | tr . _)`_size";" >> `(echo $(CURBIN) | tr . _)`.h
endef

%.shbin.o : %.v.pica %.g.pica
	@echo $(notdir $^)
	@$(call shader-as,$^)

%.shbin.o : %.v.pica
	@echo $(notdir $<)
	@$(call shader-as,$<)

%.shbin.o : %.shlist
	@echo $(notdir $<)
	@$(call shader-as,$(foreach file,$(shell cat $<),$(dir $<)/$(file)))

-include $(DEPENDS)

#---------------------------------------------------------------------------------------
endif
#---------------------------------------------------------------------------------------

=== src/step2_test_generator/CMakeLists.txt ===
include(CreateDirectoryGroups)

add_executable(step2_test_generator
    main.cpp
)
create_target_directory_groups(step2_test_generator)
target_link_libraries(step2_test_generator PRIVATE teakra)
target_include_directories(step2_test_generator PRIVATE .)
target_compile_options(step2_test_generator PRIVATE ${TEAKRA_CXX_FLAGS})

=== src/test_verifier/CMakeLists.txt ===
include(CreateDirectoryGroups)

add_executable(test_verifier
    main.cpp
)
create_target_directory_groups(test_verifier)
target_link_libraries(test_verifier PRIVATE teakra)
target_include_directories(test_verifier PRIVATE .)
target_include_directories(test_verifier PRIVATE ../../include/teakra/impl/)
target_compile_options(test_verifier PRIVATE ${TEAKRA_CXX_FLAGS})


# Test related stuff
set(ASSET_SHA256SUM "baffcd4f805a7480d969401792443a34aa39f813b4f0ae49c6365f1d1f3ce120")
if(TEAKRA_RUN_TESTS)
  message(STATUS "Will run Teakra accuracy tests")
  # download fixtures if there is none
  if(NOT EXISTS "${TEAKRA_TEST_ASSETS_DIR}/teaklite2_tests_result")
    message(STATUS "Downloading required samples...")
    file(DOWNLOAD
      "https://liushuyu.b-cdn.net/teaklite2_tests_result_20181208"
      "${TEAKRA_TEST_ASSETS_DIR}/teaklite2_tests_result"
      EXPECTED_HASH SHA256=${ASSET_SHA256SUM}
      SHOW_PROGRESS
  )
  else()
    # check if provided fixtures are good
    file(SHA256 "${TEAKRA_TEST_ASSETS_DIR}/teaklite2_tests_result" ASSET_CHECKSUM)
    if(ASSET_SHA256SUM STREQUAL ASSET_CHECKSUM)
      message(STATUS "Unit test sample looks good.")
    else()
      message(FATAL_ERROR "Unit test sample broken. Please remove the file and re-run CMake.")
    endif()
  endif()

  add_test(NAME tests COMMAND test_verifier "${TEAKRA_TEST_ASSETS_DIR}/teaklite2_tests_result")
endif(TEAKRA_RUN_TESTS)

=== debian/changelog ===
teakra (0.0~git20250805.a66efb9-1) experimental; urgency=low

  * Update to new upstream version 0.0~git20250805.a66efb9.

 -- Andrea Pappacoda <andrea@pappacoda.it>  Wed, 06 Aug 2025 14:57:35 +0200

=== debian/control ===
Source: teakra
Section: libs
Priority: optional
Maintainer: Andrea Pappacoda <tachi@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 dpkg-build-api (= 1),
 cmake (>= 3.12),
 cmark <!nodoc>,
 libcatch2-dev,
 pkg-config,
Standards-Version: 4.7.2
Homepage: https://github.com/wwylele/teakra
Vcs-Git: https://salsa.debian.org/debian/teakra.git
Vcs-Browser: https://salsa.debian.org/debian/teakra
Description: DSi/3DS DSP emulator, (dis)assembler, and tester
 Teakra is an emulator, assembler, disassembler, and tester for XpertTeak, the
 DSP used by the DSi and 3DS game consoles.
X-Style: black

Package: libteakra0
Architecture: any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: ${source:Synopsis}
 ${source:Extended-Description}
 .
 This package contains the shared library.

Package: libteakra-c0
Architecture: any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: ${source:Synopsis} - C bindings
 ${source:Extended-Description}
 .
 This package contains the shared library of the C bindings.

Package: libteakra-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libteakra-c0 (= ${binary:Version}),
 libteakra0 (= ${binary:Version}),
 ${misc:Depends},
Suggests:
 teakra-doc,
Description: ${source:Synopsis} - development
 ${source:Extended-Description}
 .
 This package contains the development files.

Package: teakra-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Description: ${source:Synopsis} - documentation
 ${source:Extended-Description}
 .
 This package contains the documentation.
